Index: tenbach-queue/INSTALL
===================================================================
--- gutenbach-queue/INSTALL	(revision 0b5842cb91e5f716eb284a3cd00ce573a6c693fc)
+++ 	(revision )
@@ -1,5 +1,0 @@
-Written by Jessica Hamrick (jhamrick).  Copyright 2009.
-
-1) build-gutenbach-queue, view-gutenbach-queue, kill-gutenbach-queue, and queue go in /usr/lib/sipbmp3/
-2) gutenbach-queue goes in /etc/init.d
-3) do `ln -s /usr/lib/sipbmp3/view-gutenbach-queue /usr/bin/view-gutenbach-queue`
Index: tenbach-queue/build-gutenbach-queue
===================================================================
--- gutenbach-queue/build-gutenbach-queue	(revision 0b5842cb91e5f716eb284a3cd00ce573a6c693fc)
+++ 	(revision )
@@ -1,15 +1,0 @@
-#!/bin/bash
-
-if [ -e /var/run/sipbmp3/current_queue_temp ]; then
-    rm /var/run/sipbmp3/current_queue_temp
-fi
-
-while true; do
-    time=$(date)
-    echo "This is a work in progress!  Please send bugs to jhamrick." >> /var/run/sipbmp3/current_queue_temp
-    echo ""
-    echo "As of $time:" >> /var/run/sipbmp3/current_queue_temp
-    /usr/lib/sipbmp3/queue >> /var/run/sipbmp3/current_queue_temp
-    mv /var/run/sipbmp3/current_queue_temp /var/run/sipbmp3/current_queue
-    chmod ugoa+r /var/run/sipbmp3/current_queue
-done
Index: gutenbach-queue/debian/changelog
===================================================================
--- gutenbach-queue/debian/changelog	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/changelog	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,5 @@
+gutenbach-queue (1.0) unstable; urgency=low
+
+  * Initial release.
+
+ -- Jessica Hamrick <jhamrick@mit.edu>  Sat, 12 Dec 2009 17:00:02 -0500
Index: gutenbach-queue/debian/compat
===================================================================
--- gutenbach-queue/debian/compat	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/compat	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,1 @@
+5
Index: gutenbach-queue/debian/control.in
===================================================================
--- gutenbach-queue/debian/control.in	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/control.in	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,14 @@
+Source: gutenbach-queue
+Section: sound
+Priority: extra
+Maintainer: Jessica Hamrick <jhamrick@mit.edu>
+Build-Depends: @cdbs@
+Standards-Version: 3.8.0
+
+Package: gutenbach-queue
+Architecture: all
+Pre-Depends: debconf
+Depends: ${shlibs:Depends}, ${misc:Depends}, daemon, gutenbach
+Description: Displays metadat about the current songs in the 
+ queue for the gutenbach music spooler, and also the song that
+ is currently playing.
Index: gutenbach-queue/debian/copyright
===================================================================
--- gutenbach-queue/debian/copyright	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/copyright	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,1 @@
+Copyright 2009 Jessica Hamrick
Index: gutenbach-queue/debian/gutenbach-queue.dirs
===================================================================
--- gutenbach-queue/debian/gutenbach-queue.dirs	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/gutenbach-queue.dirs	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,2 @@
+usr/lib/gutenbach
+usr/lib/gutenbach/queue
Index: gutenbach-queue/debian/gutenbach-queue.init
===================================================================
--- gutenbach-queue/debian/gutenbach-queue.init	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/gutenbach-queue.init	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,91 @@
+#!/bin/bash
+### BEGIN INIT INFO
+# Provides:          gutenbach-queue
+# Required-Start:    $remote_fs $syslog
+# Required-Stop:     $remote_fs $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Starts the queue daemon for gutenbach.
+# Description:       Starts the queue daemon for gutenbach.
+### END INIT INFO
+
+case "$1" in
+    start)
+	daemon -F /var/run/gutenbach/gutenbach-queue.pid --name gutenbach-queue --running
+	if [ "$?" == 0 ]; then
+	    echo "The gutenbach queue daemon is already running."
+	else
+	    if [ ! -e /var/run/gutenbach/current_queue ]; then
+		touch /var/run/gutenbach/current_queue
+		chmod ugoa+r /var/run/gutenbach/current_queue
+            fi
+            if [ ! -e /var/run/gutenbach/queue_times ]; then
+		touch /var/run/gutenbach/queue_times
+            fi
+            if [ ! -e /var/run/gutenbach/exiftool_data ]; then
+		touch /var/run/gutenbach/exiftool_data
+	    fi
+            if [ ! -e /var/run/gutenbach/current_queue_temp ]; then
+		touch /var/run/gutenbach/current_queue_temp
+            fi
+
+	    echo "Starting gutenbach daemon..."
+	    daemon -F /var/run/gutenbach/gutenbach-queue.pid --name gutenbach-queue -u daemon /usr/lib/gutenbach/queue/build-gutenbach-queue
+	    echo "Done."
+	fi
+	;;
+
+    stop)
+	daemon -F /var/run/gutenbach/gutenbach-queue.pid --stop --name gutenbach-queue
+	/usr/lib/gutenbach/queue/kill-gutenbach-queue
+
+	if [ -e /var/run/gutenbach/current_queue ]; then
+            rm /var/run/gutenbach/current_queue
+	fi
+        if [ -e /var/run/gutenbach/queue_times ]; then
+            rm /var/run/gutenbach/queue_times
+	fi
+        if [ -e /var/run/gutenbach/exiftool_data ]; then
+            rm /var/run/gutenbach/exiftool_data
+	fi
+        if [ -e /var/run/gutenbach/current_queue_temp ]; then
+            rm /var/run/gutenbach/current_queue_temp
+        fi
+	;;
+
+    restart)
+	daemon -F /var/run/gutenbach/gutenbach-queue.pid --stop --name gutenbach-queue
+        /usr/lib/gutenbach/queue/kill-gutenbach-queue
+
+	if [ -e /var/run/gutenbach/current_queue ]; then
+	    rm /var/run/gutenbach/current_queue
+	fi
+	if [ -e /var/run/gutenbach/queue_times ]; then
+	    rm /var/run/gutenbach/queue_times
+	fi
+	if [ -e /var/run/gutenbach/exiftool_data ]; then
+	    rm /var/run/gutenbach/exiftool_data
+	fi
+	if [ -e /var/run/gutenbach/current_queue_temp ]; then
+	    rm /var/run/gutenbach/current_queue_temp
+	fi
+
+	touch /var/run/gutenbach/current_queue
+	chmod ugoa+r /var/run/gutenbach/current_queue
+	touch /var/run/gutenbach/queue_times
+	touch /var/run/gutenbach/exiftool_data
+	touch /var/run/gutenbach/current_queue_temp
+
+	echo "Starting gutenbach daemon..."
+	daemon -F /var/run/gutenbach/gutenbach-queue.pid --name gutenbach-queue -u daemon /usr/lib/gutenbach/queue/build-gutenbach-queue
+	echo "Done."
+	;;
+
+    force-reload)
+	;;
+
+    *)
+	echo "Usage: $0 {start|stop|restart}"
+	exit 1
+	;;
+esac
Index: gutenbach-queue/debian/gutenbach-queue.install
===================================================================
--- gutenbach-queue/debian/gutenbach-queue.install	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/gutenbach-queue.install	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,1 @@
+debian/lib/* /usr/lib/gutenbach/queue/
Index: gutenbach-queue/debian/gutenbach-queue.postinst
===================================================================
--- gutenbach-queue/debian/gutenbach-queue.postinst	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/gutenbach-queue.postinst	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,45 @@
+#!/bin/sh
+# postinst script for gutenbach-queue
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+. /usr/share/debconf/confmodule
+
+case "$1" in
+    configure|reconfigure)
+	chmod +x /usr/lib/gutenbach/queue/build-gutenbach-queue
+	chmod +x /usr/lib/gutenbach/queue/kill-gutenbach-queue
+	chmod +x /usr/lib/queue/view-gutenbach-queue
+	chmod +x /usr/lib/queue/queue
+	ln -s /usr/lib/queue/view-gutenbach-queue /usr/bin/view-gutenbach-queue
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-queue/debian/gutenbach-queue.postrm
===================================================================
--- gutenbach-queue/debian/gutenbach-queue.postrm	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/gutenbach-queue.postrm	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,60 @@
+#!/bin/sh
+# postrm script for gutenbach-queue
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postrm> `remove'
+#        * <postrm> `purge'
+#        * <old-postrm> `upgrade' <new-version>
+#        * <new-postrm> `failed-upgrade' <old-version>
+#        * <new-postrm> `abort-install'
+#        * <new-postrm> `abort-install' <old-version>
+#        * <new-postrm> `abort-upgrade' <old-version>
+#        * <disappearer's-postrm> `disappear' <overwriter>
+#          <overwriter-version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    purge|remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
+	    if [ -d /usr/lib/gutenbach/queue ]; then
+		if [ -e /usr/lib/gutenbach/queue/build-gutenbach-queue ]; then
+		    rm /usr/lib/gutenbach/queue/build-gutenbach-queue
+		fi
+
+		if [ -e /usr/lib/gutenbach/queue/kill-gutenbach-queue ]; then
+		    rm /usr/lib/gutenbach/queue/kill-gutenbach-queue
+		fi
+
+		if [ -e /usr/lib/gutenbach/queue/queue ]; then
+		    rm /usr/lib/gutenbach/queue/queue
+		fi
+		
+		if [ -e /usr/lib/gutenbach/queue/view-gutenbach-queue ]; then
+		    rm /usr/lib/gutenbach/queue/view-gutenbach-queue
+		fi
+
+		rmdir /usr/lib/gutenbach/queue
+	    fi
+
+	    if [ -h /usr/bin/view-gutenbach-queue ]; then
+		rm /usr/bin/view-gutenbach-queue
+	    fi
+    ;;
+
+    *)
+        echo "postrm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-queue/debian/lib/build-gutenbach-queue
===================================================================
--- gutenbach-queue/debian/lib/build-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/lib/build-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,15 @@
+#!/bin/bash
+
+if [ -e /var/run/gutenbach/current_queue_temp ]; then
+    rm /var/run/gutenbach/current_queue_temp
+fi
+
+while true; do
+    time=$(date)
+    echo "This is a work in progress!  Please send bugs to jhamrick." >> /var/run/gutenbach/current_queue_temp
+    echo ""
+    echo "As of $time:" >> /var/run/gutenbach/current_queue_temp
+    /usr/lib/gutenbach/queue/queue >> /var/run/gutenbach/current_queue_temp
+    mv /var/run/gutenbach/current_queue_temp /var/run/gutenbach/current_queue
+    chmod ugoa+r /var/run/gutenbach/current_queue
+done
Index: gutenbach-queue/debian/lib/kill-gutenbach-queue
===================================================================
--- gutenbach-queue/debian/lib/kill-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/lib/kill-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,13 @@
+#!/bin/bash
+
+echo "Stopping view-gutenbach-queue..."
+killall -q "/usr/lib/gutenbach/queue/view-gutenbach-queue"
+echo "Stopping build-gutenbach-queue..."
+killall -q "/usr/lib/gutenbach/queue/build-gutenbach-queue"
+echo "Stopping queue..."
+killall -q "/usr/lib/gutenbach/queue/queue"
+echo "Stopping exiftool..."
+killall -q "/usr/bin/exiftool"
+echo "Stopping watch..."
+killall -q "/usr/bin/watch"
+echo "Done."
Index: gutenbach-queue/debian/lib/queue
===================================================================
--- gutenbach-queue/debian/lib/queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/lib/queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,52 @@
+#!/bin/bash
+
+found_current=
+
+if [ -e "/var/run/gutenbach/queue_times" ]; then
+    rm "/var/run/gutenbach/queue_times"
+fi
+
+cd /var/spool/lpd/gutenbach/
+for i in $(ls . | grep ^hf); do
+    done=$(cat "$i" | grep done)
+    if [ ! -n "$done" ]; then
+	timestamp=$(cat "$i" | grep ^job_time= | sed 's/.*=//')
+	echo "$timestamp:$i" >> /var/run/gutenbach/queue_times
+    fi
+done
+
+if [ -e /var/run/gutenbach/queue_times ]; then
+    for i in $(sort /var/run/gutenbach/queue_times); do
+	i=$(echo "$i" | sed 's/.*://')
+	prefix="df"${i:2}
+	for j in "$prefix"*; do song="$j"; done
+
+	user=$(cat "$i" | grep ^P=)
+	user=${user:2}
+    
+	if [ -e /var/run/gutenbach/exiftool_data ]; then
+	    rm /var/run/gutenbach/exiftool_data
+	fi
+
+	exiftool "$song" >> /var/run/gutenbach/exiftool_data
+	title=$(cat /var/run/gutenbach/exiftool_data | grep "^Title " | sed 's/.*: //')
+	artist=$(cat /var/run/gutenbach/exiftool_data | grep "^Artist " | sed 's/.*: //')
+
+	if [ -z "$found_current" ]; then
+	    host=$(cat "$i" | grep ^H=)
+	    host=${host:2}
+	    filenm="$(cat $i | grep "^filenames" | sed -e 's/filenames=//')"
+	    album=$(cat /var/run/gutenbach/exiftool_data | grep "^Album " | sed 's/.*: //')
+	    echo "$user@$host is currently playing: "
+	    echo "$filenm"
+	    echo "'$title'"
+	    echo "by '$artist'"
+	    echo "on '$album'"
+	    echo ""
+	    echo "Coming up in the queue:"
+	    found_current="true" 
+	else
+	    echo "$user: '$title' by '$artist'"
+	fi
+    done
+fi
Index: gutenbach-queue/debian/lib/view-gutenbach-queue
===================================================================
--- gutenbach-queue/debian/lib/view-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/lib/view-gutenbach-queue	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,8 @@
+#!/bin/bash
+
+daemon --running --name gutenbach-queue -F /var/run/gutenbach/gutenbach-queue.pid
+if [ "$?" == 0 ]; then
+    watch -t -n 1 cat /var/run/gutenbach/current_queue
+else
+    echo "The gutenbach queue daemon is not running.  Please start it at /etc/init.d/gutenbach-queue."
+fi
Index: gutenbach-queue/debian/rules
===================================================================
--- gutenbach-queue/debian/rules	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
+++ gutenbach-queue/debian/rules	(revision 39452be9026f73731bf1e03a452fa1e0fb56fd58)
@@ -0,0 +1,3 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: tenbach-queue/gutenbach-queue
===================================================================
--- gutenbach-queue/gutenbach-queue	(revision 0b5842cb91e5f716eb284a3cd00ce573a6c693fc)
+++ 	(revision )
@@ -1,79 +1,0 @@
-#!/bin/bash
-
-case "$1" in
-    start)
-	daemon -F /var/run/sipbmp3/gutenbach-queue.pid --name gutenbach-queue --running
-	if [ "$?" == 0 ]; then
-	    echo "The gutenbach queue daemon is already running."
-	else
-	    if [ ! -e /var/run/sipbmp3/current_queue ]; then
-		touch /var/run/sipbmp3/current_queue
-		chmod ugoa+r /var/run/sipbmp3/current_queue
-            fi
-            if [ ! -e /var/run/sipbmp3/queue_times ]; then
-		touch /var/run/sipbmp3/queue_times
-            fi
-            if [ ! -e /var/run/sipbmp3/exiftool_data ]; then
-		touch /var/run/sipbmp3/exiftool_data
-	    fi
-            if [ ! -e /var/run/sipbmp3/current_queue_temp ]; then
-		touch /var/run/sipbmp3/current_queue_temp
-            fi
-
-	    echo "Starting gutenbach daemon..."
-	    daemon -F /var/run/sipbmp3/gutenbach-queue.pid --name gutenbach-queue -u daemon /usr/lib/sipbmp3/build-gutenbach-queue
-	    echo "Done."
-	fi
-	;;
-
-    stop)
-	daemon -F /var/run/sipbmp3/gutenbach-queue.pid --stop --name gutenbach-queue
-	/usr/lib/sipbmp3/kill-gutenbach-queue
-
-	if [ -e /var/run/sipbmp3/current_queue ]; then
-            rm /var/run/sipbmp3/current_queue
-	fi
-        if [ -e /var/run/sipbmp3/queue_times ]; then
-            rm /var/run/sipbmp3/queue_times
-	fi
-        if [ -e /var/run/sipbmp3/exiftool_data ]; then
-            rm /var/run/sipbmp3/exiftool_data
-	fi
-        if [ -e /var/run/sipbmp3/current_queue_temp ]; then
-            rm /var/run/sipbmp3/current_queue_temp
-        fi
-	;;
-
-    restart)
-	daemon -F /var/run/sipbmp3/gutenbach-queue.pid --stop --name gutenbach-queue
-        /usr/lib/sipbmp3/kill-gutenbach-queue
-
-	if [ -e /var/run/sipbmp3/current_queue ]; then
-	    rm /var/run/sipbmp3/current_queue
-	fi
-	if [ -e /var/run/sipbmp3/queue_times ]; then
-	    rm /var/run/sipbmp3/queue_times
-	fi
-	if [ -e /var/run/sipbmp3/exiftool_data ]; then
-	    rm /var/run/sipbmp3/exiftool_data
-	fi
-	if [ -e /var/run/sipbmp3/current_queue_temp ]; then
-	    rm /var/run/sipbmp3/current_queue_temp
-	fi
-
-	touch /var/run/sipbmp3/current_queue
-	chmod ugoa+r /var/run/sipbmp3/current_queue
-	touch /var/run/sipbmp3/queue_times
-	touch /var/run/sipbmp3/exiftool_data
-	touch /var/run/sipbmp3/current_queue_temp
-
-	echo "Starting gutenbach daemon..."
-	daemon -F /var/run/sipbmp3/gutenbach-queue.pid --name gutenbach-queue -u daemon /usr/lib/sipbmp3/build-gutenbach-queue
-	echo "Done."
-	;;
-
-    *)
-	echo "Usage: $0 {start|stop|restart}"
-	exit 1
-	;;
-esac
Index: tenbach-queue/kill-gutenbach-queue
===================================================================
--- gutenbach-queue/kill-gutenbach-queue	(revision 0b5842cb91e5f716eb284a3cd00ce573a6c693fc)
+++ 	(revision )
@@ -1,13 +1,0 @@
-#!/bin/bash
-
-echo "Stopping view-gutenbach-queue..."
-killall -q "/usr/lib/sipbmp3/view-gutenbach-queue"
-echo "Stopping build-gutenbach-queue..."
-killall -q "/usr/lib/sipbmp3/build-gutenbach-queue"
-echo "Stopping queue..."
-killall -q "/usr/lib/sipbmp3/queue"
-echo "Stopping exiftool..."
-killall -q "/usr/bin/exiftool"
-echo "Stopping watch..."
-killall -q "/usr/bin/watch"
-echo "Done."
Index: tenbach-queue/queue
===================================================================
--- gutenbach-queue/queue	(revision 7f94ef02459eeb0c16841a9e99f3e5e1905a2db5)
+++ 	(revision )
@@ -1,52 +1,0 @@
-#!/bin/bash
-
-found_current=
-
-if [ -e "/var/run/sipbmp3/queue_times" ]; then
-    rm "/var/run/sipbmp3/queue_times"
-fi
-
-cd /var/spool/lpd/sipbmp3/
-for i in $(ls . | grep ^hf); do
-    done=$(cat "$i" | grep done)
-    if [ ! -n "$done" ]; then
-	timestamp=$(cat "$i" | grep ^job_time= | sed 's/.*=//')
-	echo "$timestamp:$i" >> /var/run/sipbmp3/queue_times
-    fi
-done
-
-if [ -e /var/run/sipbmp3/queue_times ]; then
-    for i in $(sort /var/run/sipbmp3/queue_times); do
-	i=$(echo "$i" | sed 's/.*://')
-	prefix="df"${i:2}
-	for j in "$prefix"*; do song="$j"; done
-
-	user=$(cat "$i" | grep ^P=)
-	user=${user:2}
-    
-	if [ -e /var/run/sipbmp3/exiftool_data ]; then
-	    rm /var/run/sipbmp3/exiftool_data
-	fi
-
-	exiftool "$song" >> /var/run/sipbmp3/exiftool_data
-	title=$(cat /var/run/sipbmp3/exiftool_data | grep "^Title " | sed 's/.*: //')
-	artist=$(cat /var/run/sipbmp3/exiftool_data | grep "^Artist " | sed 's/.*: //')
-
-	if [ -z "$found_current" ]; then
-	    host=$(cat "$i" | grep ^H=)
-	    host=${host:2}
-	    filenm="$(cat $i | grep "^filenames" | sed -e 's/filenames=//')"
-	    album=$(cat /var/run/sipbmp3/exiftool_data | grep "^Album " | sed 's/.*: //')
-	    echo "$user@$host is currently playing: "
-	    echo "$filenm"
-	    echo "'$title'"
-	    echo "by '$artist'"
-	    echo "on '$album'"
-	    echo ""
-	    echo "Coming up in the queue:"
-	    found_current="true" 
-	else
-	    echo "$user: '$title' by '$artist'"
-	fi
-    done
-fi
Index: tenbach-queue/view-gutenbach-queue
===================================================================
--- gutenbach-queue/view-gutenbach-queue	(revision 0b5842cb91e5f716eb284a3cd00ce573a6c693fc)
+++ 	(revision )
@@ -1,8 +1,0 @@
-#!/bin/bash
-
-daemon --running --name gutenbach-queue -F /var/run/sipbmp3/gutenbach-queue.pid
-if [ "$?" == 0 ]; then
-    watch -t -n 1 cat /var/run/sipbmp3/current_queue
-else
-    echo "The gutenbach queue daemon is not running.  Please start it at /etc/init.d/gutenbach-queue."
-fi