Index: gutenbach-remctl/.gitignore
===================================================================
--- gutenbach-remctl/.gitignore	(revision 807ecdbc174665fa33a08e2b21a635d8c5c8ca18)
+++ gutenbach-remctl/.gitignore	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,6 +1,1 @@
 *~
-vm*
-ksplice*
-voldaemon
-log
-printcap
Index: gutenbach-remctl/cd
===================================================================
--- gutenbach-remctl/cd	(revision 69915637b7b8a9743780f937d6e20598df671f78)
+++ gutenbach-remctl/cd	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,3 +1,3 @@
-cd cddb     /usr/lib/gutenbach/cd-cddb     ANYUSER
-cd cddb-get /usr/lib/gutenbach/cd-cddb-get ANYUSER
-cd play     /usr/lib/gutenbach/cd-play     ANYUSER
+cd cddb     /usr/lib/gutenbach/remctl/cd-cddb     ANYUSER
+cd cddb-get /usr/lib/gutenbach/remctl/cd-cddb-get ANYUSER
+cd play     /usr/lib/gutenbach/remctl/cd-play     ANYUSER
Index: gutenbach-remctl/cd-cddb-get
===================================================================
--- gutenbach-remctl/cd-cddb-get	(revision 6bb3ffb249dc254896b2f89be72367ae76fad5e9)
+++ gutenbach-remctl/cd-cddb-get	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -3,6 +3,6 @@
 
 CDDBURL="http://freedb.freedb.org/~cddb/cddb.cgi"
-MYUSER="sipbmp3"
-MYHOST="zsr.mit.edu"
+MYUSER="gutenbach"
+MYHOST=`hostname`".mit.edu"
 
 DISCID=$(cd-discid /dev/cdrom 2>/dev/null) || exit 1
@@ -13,7 +13,7 @@
 TRACKS="$2"
 
-mkdir -p /var/cache/sipbmp3
+mkdir -p /var/cache/gutenbach
 
-CACHEFILE="/var/cache/sipbmp3/$ID"
+CACHEFILE="/var/cache/gutenbach/$ID"
 
 if [ ! -e "$CACHEFILE" ]; then
Index: gutenbach-remctl/cd-play
===================================================================
--- gutenbach-remctl/cd-play	(revision 6bb3ffb249dc254896b2f89be72367ae76fad5e9)
+++ gutenbach-remctl/cd-play	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -5,4 +5,6 @@
 
 CACHE=$(cd-cddb-get)
+
+printername=$(/usr/lib/gutenbach/gutenbach-get-config queue)
 
 if [ "$?" = 0 ]; then
@@ -18,5 +20,5 @@
     fi
 
-    echo "cdda://$(($T - 1))" | mit-lpr -Psipbmp3@localhost -J "Track $T$DESC";
+    echo "cdda://$(($T - 1))" | mit-lpr -P"$queue"@localhost -J "Track $T$DESC";
     echo "Queued Track $T$DESC";
 }
Index: gutenbach-remctl/changelog
===================================================================
--- gutenbach-remctl/changelog	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/changelog	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,5 @@
+gutenbach-remctl (1.0) unstable; urgency=low
+
+  * Initial release.
+
+ -- Jessica Hamrick <jhamrick@mit.edu>  Sun, 13 Dec 2009 11:34:29 -0500
Index: gutenbach-remctl/compat
===================================================================
--- gutenbach-remctl/compat	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/compat	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,1 @@
+5
Index: gutenbach-remctl/control.in
===================================================================
--- gutenbach-remctl/control.in	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/control.in	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,13 @@
+Source: gutenbach-remctl
+Section: sound
+Priority: extra
+Maintainer: Jessica Hamrick <jhamrick@mit.edu>
+Build-Depends: @cdbs@
+Standards-Version: 3.8.0
+
+Package: gutenbach-remctl
+Architecture: all
+Pre-Depends: debconf
+Depends: ${shlibs:Depends}, ${misc:Depends}, gutenbach, alsa-utils, cd-discid, remctl-server
+Description: Allows a remote user to control the volume, view
+ the current status of the queue, or play tracks from a cd.
Index: gutenbach-remctl/copyright
===================================================================
--- gutenbach-remctl/copyright	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/copyright	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,1 @@
+Copyright 2009 Jessica Hamrick
Index: gutenbach-remctl/gutenbach-remctl.dirs
===================================================================
--- gutenbach-remctl/gutenbach-remctl.dirs	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/gutenbach-remctl.dirs	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,3 @@
+usr/lib/gutenbach
+usr/lib/gutenbach/remctl
+etc/remctl/conf.d
Index: gutenbach-remctl/gutenbach-remctl.init
===================================================================
--- gutenbach-remctl/gutenbach-remctl.init	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/gutenbach-remctl.init	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,114 @@
+#!/bin/bash
+### BEGIN INIT INFO
+# Provides:          gutenbach-remctl
+# Required-Start:    $remote_fs $syslog
+# Required-Stop:     $remote_fs $syslog
+# Default-Start:     2 3 4 5
+# Default-Stop:      0 1 6
+# Short-Description: Starts remctld.
+# Description:       Starts remctld.
+### END INIT INFO
+
+case "$1" in
+    start)
+	if [ -e /var/run/gutenbach/remctld.pid ]; then
+	    pid=$(cat /var/run/gutenbach/remctld.pid)
+	    if [ -n "$pid" ]; then
+		kill -0 "$pid"
+		if [ "$?" == 0 ]; then
+		    echo "Ending remctld..." >&2
+		    kill "$pid" || true
+		fi
+	    fi
+	fi
+
+	pid=$(sudo lsof -i :4373 | grep remctld | sed s/remctld\ // | sed s/\ .*//)
+	if [ -n "$pid" ]; then
+	    kill -0 "$pid"
+	    if [ "$?" == 0 ]; then
+		echo "Ending remctld socket binding..." >&2
+		kill "$pid" || true
+	    fi
+	fi
+
+	echo "Starting remctld..." >&2
+	remctld -m -P /var/run/gutenbach/remctld.pid &
+	;;
+
+    stop)
+	if [ -e /var/run/gutenbach/remctld.pid ]; then
+	    pid=$(cat /var/run/gutenbach/remctld.pid)
+	    if [ -n "$pid" ]; then
+		kill -0 "$pid"
+		if [ "$?" == 0 ]; then
+		    echo "Ending remctld..." >&2
+		    kill "$pid" || true
+		fi
+	    fi
+	fi
+
+	pid=$(sudo lsof -i :4373 | grep remctld | sed s/remctld\ // | sed s/\ .*//)
+	if [ -n "$pid" ]; then
+	    kill -0 "$pid"
+	    if [ "$?" == 0 ]; then
+		echo "Ending remctld socket binding..." >&2
+		kill "$pid" || true
+	    fi
+	fi
+	;;
+
+    restart)
+	if [ -e /var/run/gutenbach/remctld.pid ]; then
+	    pid=$(cat /var/run/gutenbach/remctld.pid)
+	    if [ -n "$pid" ]; then
+		kill -0 "$pid"
+		if [ "$?" == 0 ]; then
+		    echo "Ending remctld..." >&2
+		    kill "$pid" || true
+		fi
+	    fi
+	fi
+
+	pid=$(sudo lsof -i :4373 | grep remctld | sed s/remctld\ // | sed s/\ .*//)
+	if [ -n "$pid" ]; then
+	    kill -0 "$pid"
+	    if [ "$?" == 0 ]; then
+		echo "Ending remctld socket binding..." >&2
+		kill "$pid" || true
+	    fi
+	fi
+
+	echo "Starting remctld..." >&2
+	remctld -m -P /var/run/gutenbach/remctld.pid &
+	;;
+
+    force-reload)
+	if [ -e /var/run/gutenbach/remctld.pid ]; then
+	    pid=$(cat /var/run/gutenbach/remctld.pid)
+	    if [ -n "$pid" ]; then
+		kill -0 "$pid"
+		if [ "$?" == 0 ]; then
+		    echo "Ending remctld..." >&2
+		    kill "$pid" || true
+		fi
+	    fi
+	fi
+
+	pid=$(sudo lsof -i :4373 | grep remctld | sed s/remctld\ // | sed s/\ .*//)
+	if [ -n "$pid" ]; then
+	    kill -0 "$pid"
+	    if [ "$?" == 0 ]; then
+		echo "Ending remctld socket binding..." >&2
+		kill "$pid" || true
+	    fi
+	fi
+
+	echo "Starting remctld..." >&2
+	remctld -m -P /var/run/gutenbach/remctld.pid &
+	;;
+
+    *)
+	echo "Usage: $0 {start|stop|restart}"
+	exit 1
+	;;
+esac
Index: gutenbach-remctl/gutenbach-remctl.install
===================================================================
--- gutenbach-remctl/gutenbach-remctl.install	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/gutenbach-remctl.install	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,2 @@
+debian/lib/for-gutenbach/* /usr/lib/gutenbach/remctl/
+debian/lib/for-remctl/* /etc/remctl/conf.d/
Index: gutenbach-remctl/gutenbach-remctl.postinst
===================================================================
--- gutenbach-remctl/gutenbach-remctl.postinst	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/gutenbach-remctl.postinst	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,52 @@
+#!/bin/sh
+# postinst script for gutenbach-remctl
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postinst> `configure' <most-recently-configured-version>
+#        * <old-postinst> `abort-upgrade' <new version>
+#        * <conflictor's-postinst> `abort-remove' `in-favour' <package>
+#          <new-version>
+#        * <postinst> `abort-remove'
+#        * <deconfigured's-postinst> `abort-deconfigure' `in-favour'
+#          <failed-install-package> <version> `removing'
+#          <conflicting-package> <version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+case "$1" in
+    configure|reconfigure)
+	chmod +x /usr/lib/gutenbach/remctl/cd-cddb
+	chmod +x /usr/lib/gutenbach/remctl/cd-cddb-get
+	chmod +x /usr/lib/gutenbach/remctl/cd-play
+	chmod +x /usr/lib/gutenbach/remctl/status-clear
+	chmod +x /usr/lib/gutenbach/remctl/status-get
+	chmod +x /usr/lib/gutenbach/remctl/volume-down
+	chmod +x /usr/lib/gutenbach/remctl/volume-get
+	chmod +x /usr/lib/gutenbach/remctl/volume-help
+	chmod +x /usr/lib/gutenbach/remctl/volume-is-muted
+	chmod +x /usr/lib/gutenbach/remctl/volume-mute
+	chmod +x /usr/lib/gutenbach/remctl/volume-set
+	chmod +x /usr/lib/gutenbach/remctl/volume-show
+	chmod +x /usr/lib/gutenbach/remctl/volume-up
+	chmod +x /usr/lib/gutenbach/remctl/volume-zephyr
+    ;;
+
+    abort-upgrade|abort-remove|abort-deconfigure)
+    ;;
+
+    *)
+        echo "postinst called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-remctl/gutenbach-remctl.postrm
===================================================================
--- gutenbach-remctl/gutenbach-remctl.postrm	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/gutenbach-remctl.postrm	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,49 @@
+#!/bin/sh
+# postrm script for gutenbach-remctl
+#
+# see: dh_installdeb(1)
+
+set -e
+
+# summary of how this script can be called:
+#        * <postrm> `remove'
+#        * <postrm> `purge'
+#        * <old-postrm> `upgrade' <new-version>
+#        * <new-postrm> `failed-upgrade' <old-version>
+#        * <new-postrm> `abort-install'
+#        * <new-postrm> `abort-install' <old-version>
+#        * <new-postrm> `abort-upgrade' <old-version>
+#        * <disappearer's-postrm> `disappear' <overwriter>
+#          <overwriter-version>
+# for details, see http://www.debian.org/doc/debian-policy/ or
+# the debian-policy package
+
+
+case "$1" in
+    purge|remove|upgrade|failed-upgrade|abort-install|abort-upgrade|disappear)
+	if [ "$1" = "purge" ]; then
+	    if [ -e /usr/lib/gutenbach/remctl ]; then
+		echo "Removing /usr/lib/gutenbach/remctl/ ..." >&2
+		rm -r  /usr/lib/gutenbach/remctl
+	    fi
+
+	    if [ -e /etc/remctl/conf.d ]; then
+		echo "Removing /etc/remctl/conf.d ..." >&2
+		rm /etc/remctl/conf.d
+		mkdir /etc/remctl/conf.d
+	    fi
+     	fi
+    ;;
+
+    *)
+        echo "postrm called with unknown argument \`$1'" >&2
+        exit 1
+    ;;
+esac
+
+# dh_installdeb will replace this with shell code automatically
+# generated by other debhelper scripts.
+
+#DEBHELPER#
+
+exit 0
Index: gutenbach-remctl/rules
===================================================================
--- gutenbach-remctl/rules	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
+++ gutenbach-remctl/rules	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -0,0 +1,3 @@
+#!/usr/bin/make -f
+
+include /usr/share/cdbs/1/rules/debhelper.mk
Index: gutenbach-remctl/status
===================================================================
--- gutenbach-remctl/status	(revision 69915637b7b8a9743780f937d6e20598df671f78)
+++ gutenbach-remctl/status	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,2 +1,2 @@
-status get   /usr/lib/gutenbach/status-get   ANYUSER
-status clear /usr/lib/gutenbach/status-clear ANYUSER
+status get   /usr/lib/gutenbach/remctl/status-get   ANYUSER
+status clear /usr/lib/gutenbach/remctl/status-clear ANYUSER
Index: gutenbach-remctl/status-clear
===================================================================
--- gutenbach-remctl/status-clear	(revision 6bb3ffb249dc254896b2f89be72367ae76fad5e9)
+++ gutenbach-remctl/status-clear	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,3 +1,3 @@
 #!/bin/sh
 PATH="$(dirname $0):$PATH"
-> /var/run/sipbmp3/status
+> /var/run/gutenbach/status
Index: gutenbach-remctl/status-get
===================================================================
--- gutenbach-remctl/status-get	(revision 6bb3ffb249dc254896b2f89be72367ae76fad5e9)
+++ gutenbach-remctl/status-get	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,3 +1,3 @@
 #!/bin/sh
 PATH="$(dirname $0):$PATH"
-cat /var/run/sipbmp3/status
+cat /var/run/gutenbach/status
Index: gutenbach-remctl/volume
===================================================================
--- gutenbach-remctl/volume	(revision 69915637b7b8a9743780f937d6e20598df671f78)
+++ gutenbach-remctl/volume	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,25 +1,25 @@
-volume set  /usr/lib/gutenbach/volume-set	 ANYUSER 
-volume get  /usr/lib/gutenbach/volume-get    ANYUSER
-volume show /usr/lib/gutenbach/volume-show   ANYUSER
-volume mute /usr/lib/gutenbach/volume-mute   ANYUSER 
-volume up   /usr/lib/gutenbach/volume-up     ANYUSER 
-volume down /usr/lib/gutenbach/volume-down   ANYUSER 
-volume is-muted /usr/lib/gutenbach/volume-is-muted   ANYUSER 
+volume set  /usr/lib/gutenbach/remctl/volume-set	 ANYUSER 
+volume get  /usr/lib/gutenbach/remctl/volume-get    ANYUSER
+volume show /usr/lib/gutenbach/remctl/volume-show   ANYUSER
+volume mute /usr/lib/gutenbach/remctl/volume-mute   ANYUSER 
+volume up   /usr/lib/gutenbach/remctl/volume-up     ANYUSER 
+volume down /usr/lib/gutenbach/remctl/volume-down   ANYUSER 
+volume is-muted /usr/lib/gutenbach/remctl/volume-is-muted   ANYUSER 
 
-v set  /usr/lib/gutenbach/volume-set    ANYUSER 
-v get  /usr/lib/gutenbach/volume-get    ANYUSER
-v show /usr/lib/gutenbach/volume-show   ANYUSER
-v mute /usr/lib/gutenbach/volume-mute   ANYUSER 
-v up   /usr/lib/gutenbach/volume-up     ANYUSER 
-v down /usr/lib/gutenbach/volume-down   ANYUSER 
-v is-muted /usr/lib/gutenbach/volume-is-muted   ANYUSER 
+v set  /usr/lib/gutenbach/remctl/volume-set    ANYUSER 
+v get  /usr/lib/gutenbach/remctl/volume-get    ANYUSER
+v show /usr/lib/gutenbach/remctl/volume-show   ANYUSER
+v mute /usr/lib/gutenbach/remctl/volume-mute   ANYUSER 
+v up   /usr/lib/gutenbach/remctl/volume-up     ANYUSER 
+v down /usr/lib/gutenbach/remctl/volume-down   ANYUSER 
+v is-muted /usr/lib/gutenbach/remctl/volume-is-muted   ANYUSER 
 
-v u /usr/lib/gutenbach/volume-up   ANYUSER
-v d /usr/lib/gutenbach/volume-down ANYUSER
+v u /usr/lib/gutenbach/remctl/volume-up   ANYUSER
+v d /usr/lib/gutenbach/remctl/volume-down ANYUSER
 
-volume u /usr/lib/gutenbach/volume-up   ANYUSER
-volume d /usr/lib/gutenbach/volume-down ANYUSER
+volume u /usr/lib/gutenbach/remctl/volume-up   ANYUSER
+volume d /usr/lib/gutenbach/remctl/volume-down ANYUSER
 
-volume help /usr/lib/gutenbach/volume-help ANYUSER
-v      help /usr/lib/gutenbach/volume-help ANYUSER
-help   ALL  /usr/lib/gutenbach/volume-help ANYUSER
+volume help /usr/lib/gutenbach/remctl/volume-help ANYUSER
+v      help /usr/lib/gutenbach/remctl/volume-help ANYUSER
+help   ALL  /usr/lib/gutenbach/remctl/volume-help ANYUSER
Index: gutenbach-remctl/volume-get
===================================================================
--- gutenbach-remctl/volume-get	(revision 9f011cf53bded54285e284cc5f4eda76e3b8ed92)
+++ gutenbach-remctl/volume-get	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -2,6 +2,6 @@
 PATH="$(dirname $0):$PATH"
 
-mixer=$(sipbmp3-get-config mixer)
-channel=$(sipbmp3-get-config channel)
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
 
 amixer get $mixer | grep "$channel" \
Index: gutenbach-remctl/volume-is-muted
===================================================================
--- gutenbach-remctl/volume-is-muted	(revision 8ed9a02c5787d49ad4d662ec017ecf283a56904f)
+++ gutenbach-remctl/volume-is-muted	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -2,6 +2,6 @@
 PATH="$(dirname $0):$PATH"
 
-mixer=$(sipbmp3-get-config mixer)
-channel=$(sipbmp3-get-config channel)
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
 
 volstat=$(amixer get $mixer | grep "$channel" \
Index: gutenbach-remctl/volume-mute
===================================================================
--- gutenbach-remctl/volume-mute	(revision 436e9011224da6b48798d3c6780908e1b08d3070)
+++ gutenbach-remctl/volume-mute	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -2,6 +2,6 @@
 PATH="$(dirname $0):$PATH"
 
-mixer=$(sipbmp3-get-config mixer)
-channel=$(sipbmp3-get-config channel)
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
 
 amixer set $mixer toggle > /dev/null
Index: gutenbach-remctl/volume-set
===================================================================
--- gutenbach-remctl/volume-set	(revision 8ed9a02c5787d49ad4d662ec017ecf283a56904f)
+++ gutenbach-remctl/volume-set	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -2,6 +2,6 @@
 PATH="$(dirname $0):$PATH"
 
-mixer=$(sipbmp3-get-config mixer)
-channel="$(sipbmp3-get-config channel)"
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
 
 amixer set $mixer "$2" | grep "$channel" \
Index: gutenbach-remctl/volume-show
===================================================================
--- gutenbach-remctl/volume-show	(revision 8ed9a02c5787d49ad4d662ec017ecf283a56904f)
+++ gutenbach-remctl/volume-show	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -2,6 +2,6 @@
 PATH="$(dirname $0):$PATH"
 
-mixer=$(sipbmp3-get-config mixer)
-channel=$(sipbmp3-get-config channel)
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
 
 amixer get $mixer
Index: gutenbach-remctl/volume-zephyr
===================================================================
--- gutenbach-remctl/volume-zephyr	(revision 8accd74888c5951ac3a72423fd8656dc1ed1b89f)
+++ gutenbach-remctl/volume-zephyr	(revision 53936a5ce93f322effc45c0b2fadff6a4d0478ec)
@@ -1,11 +1,18 @@
 #!/bin/sh
 PATH="$(dirname $0):$PATH"
-class=$(sipbmp3-get-config zephyr-class)
-host=$(sipbmp3-get-config host)
-queue=$(sipbmp3-get-config queue)
+class=$(/usr/lib/gutenbach/gutenbach-get-config zephyr-class)
+host=$(/usr/lib/gutenbach/gutenbach-get-config host)
+queue=$(/usr/lib/gutenbach/gutenbach-get-config queue)
 instance="$queue-volume@$host"
 
-mixer=$(sipbmp3-get-config mixer)
-channel=$(sipbmp3-get-config channel)
+mixer=$(/usr/lib/gutenbach/gutenbach-get-config mixer)
+channel=$(/usr/lib/gutenbach/gutenbach-get-config channel)
+
+echo "Class: $class" >> /tmp/gutenbach-remctl.log
+echo "Host: $host" >> /tmp/gutenbach-remctl.log
+echo "Queue: $queue" >> /tmp/gutenbach-remctl.log
+echo "Instance: $instance" >> /tmp/gutenbach-remctl.log
+echo "Mixer: $mixer" >> /tmp/gutenbach-remctl.log
+echo "Channel: $channel" >> /tmp/gutenbach-remctl.log
 
 muted=$(volume-is-muted)
@@ -15,4 +22,7 @@
 fi
 
-start-stop-daemon --stop --oknodo --pidfile /var/run/sipbmp3-zephyr >/dev/null 2>&1
-start-stop-daemon --start --pidfile /var/run/sipbmp3-zephyr --make-pidfile --background --exec /bin/sh -- -c "sleep 10 && zwrite -c $class -i $instance -d -n -m '$REMOTE_USER set volume $(volume-get)$mute_str' > /dev/null" >/dev/null 2>&1
+start-stop-daemon --stop --oknodo --pidfile /usr/lib/gutenbach/gutenbach-zephyr >/dev/null 2>&1
+start-stop-daemon --start --pidfile /usr/lib/gutenbach/gutenbach-zephyr --make-pidfile --background --exec /bin/sh -- -c "sleep 10 && zwrite -c $class -i $instance -d -n -m '$REMOTE_USER set volume $(volume-get)$mute_str' > /dev/null" >/dev/null 2>&1
+
+echo "sleep 10 && zwrite -c $class -i $instance -d -n -m '$REMOTE_USER set volume $(volume-get)$mute_str' > /dev/null" >> /tmp/gutenbach-remctl.log
+echo "" >> /tmp/gutenbach-remctl.log