Index: Makefile
===================================================================
--- Makefile	(revision 9c0279ee584d72ca543f631999621c6c1afac43e)
+++ Makefile	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -5,2 +5,4 @@
 install:
 	for d in $(DIRS); do (cd $$d; $(MAKE) install); done
+clean:
+	for d in $(DIRS); do (cd $$d; $(MAKE) clean); done
Index: client/Makefile
===================================================================
--- client/Makefile	(revision ae7cf76f0d0dfc741647ecb24342144acb212179)
+++ client/Makefile	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
Index: debian/control
===================================================================
--- debian/control	(revision 7009a01877fe5b875e4e9a7df49bd012a428dabf)
+++ debian/control	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -3,4 +3,5 @@
 Priority: extra
 Maintainer: Jessica Hamrick <jhamrick@mit.edu>
+Uploaders: Kyle Brogle <broglek@bu.edu>, Quentin Smith <quentin@mit.edu>, Yuri Lin <rye@mit.edu>
 Build-Depends: cdbs, debhelper (>= 5)
 Standards-Version: 3.8.4
Index: debian/gutenbach-remctl.config
===================================================================
--- debian/gutenbach-remctl.config	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
+++ debian/gutenbach-remctl.config	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -0,0 +1,23 @@
+#!/bin/sh -e
+
+# Source debconf library.
+. /usr/share/debconf/confmodule
+
+mixer=""
+channel=""
+
+
+if [ -e /usr/lib/gutenbach/remctl/config/mixer ]; then
+    mixer=$(cat /usr/lib/gutenbach/remctl/config/mixer)
+    db_set gutenbach-remctl/mixer "$mixer"
+fi
+
+if [ -e /usr/lib/gutenbach/remctl/config/channel ]; then
+    channel=$(cat /usr/lib/gutenbach/remctl/config/channel)
+    db_set gutenbach-remctl/channel "$channel"
+fi
+
+db_input high gutenbach-remctl/mixer || true
+db_input high gutenbach-remctl/channel || true
+db_go || true
+
Index: debian/gutenbach-remctl.dirs
===================================================================
--- debian/gutenbach-remctl.dirs	(revision 632040d1abb23e31a5b3443dc2dc6fcd0dae8108)
+++ debian/gutenbach-remctl.dirs	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -1,3 +1,4 @@
 usr/lib/gutenbach
 usr/lib/gutenbach/remctl
+usr/lib/gutenbach/remctl/config
 etc/remctl/conf.d
Index: debian/gutenbach-remctl.install
===================================================================
--- debian/gutenbach-remctl.install	(revision 632040d1abb23e31a5b3443dc2dc6fcd0dae8108)
+++ debian/gutenbach-remctl.install	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
Index: debian/gutenbach-remctl.postinst
===================================================================
--- debian/gutenbach-remctl.postinst	(revision 632040d1abb23e31a5b3443dc2dc6fcd0dae8108)
+++ debian/gutenbach-remctl.postinst	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -5,5 +5,5 @@
 
 set -e
-
+. /usr/share/debconf/confmodule
 # summary of how this script can be called:
 #        * <postinst> `configure' <most-recently-configured-version>
Index: debian/gutenbach-remctl.templates
===================================================================
--- debian/gutenbach-remctl.templates	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
+++ debian/gutenbach-remctl.templates	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -0,0 +1,11 @@
+Template: gutenbach-remctl/mixer
+Type: string
+_Description: The mixer that gutenbach uses:
+ Gutenbach remctl needs the name of the mixer in order
+ to control the volume of the music server. [Default is "PCM"]
+
+Template: gutenbach-remctl/channel
+Type: string
+_Description: The mixer channel that gutenbach uses:
+ Gutenbach remctl needs a channel on the mixer in order
+ to control the volume of the music server. [Default is "Left Front"]
Index: debian/gutenbach-server.templates
===================================================================
--- debian/gutenbach-server.templates	(revision 632040d1abb23e31a5b3443dc2dc6fcd0dae8108)
+++ debian/gutenbach-server.templates	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -5,6 +5,6 @@
  files.  gutenbach needs to know what you want to call the 
  printer, and then after installation, you will be able
- to do:
- lpr -Pprintername@hostname your-music-file-.mp3 
+ to use scripts in the gutenbach-client package or lpr
+ to interact with the server. 
 
 Template: gutenbach-server/zephyrclass
Index: debian/po/POTFILES.in
===================================================================
--- debian/po/POTFILES.in	(revision 181763598bb1d4be07eccd13f09bc892fad3c732)
+++ debian/po/POTFILES.in	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -1,1 +1,2 @@
 [type: gettext/rfc822deb] gutenbach-server.templates
+[type: gettext/rfc822deb] gutenbach-remctl.templates
Index: debian/po/templates.pot
===================================================================
--- debian/po/templates.pot	(revision 181763598bb1d4be07eccd13f09bc892fad3c732)
+++ debian/po/templates.pot	(revision 21166157fd11ddc31d666f97b42e46e182757b03)
@@ -1,13 +1,13 @@
-# Gutenbach Translation File.
-#
-# This file is distributed under the same license as the GUTENBACH package.
+# GUTENBACH TRANSLATION FILE.
+# Copyright 2010
+# This file is distributed under the same license as the gutenbach-server package.
 # Jessica B. Hamrick <jhamrick@mit.edu>, 2010.
 #
-#
+#, fuzzy
 msgid ""
 msgstr ""
-"Project-Id-Version: PACKAGE VERSION\n"
+"Project-Id-Version: 2.12\n"
 "Report-Msgid-Bugs-To: gutenbach@mit.edu\n"
-"POT-Creation-Date: 2010-06-14 18:36-0600\n"
+"POT-Creation-Date: 2010-08-14 16:11-0400\n"
 "PO-Revision-Date: YEAR-MO-DA HO:MI+ZONE\n"
 "Last-Translator: FULL NAME <EMAIL@ADDRESS>\n"
@@ -63,2 +63,30 @@
 "or something else shorter."
 msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach-remctl.templates:1001
+msgid "The mixer that gutenbach uses:"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach-remctl.templates:1001
+msgid ""
+"Gutenbach remctl needs the name of the mixer in order to control the volume "
+"of the music server. [Default is \"PCM\"]"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach-remctl.templates:2001
+msgid "The mixer channel that gutenbach uses:"
+msgstr ""
+
+#. Type: string
+#. Description
+#: ../gutenbach-remctl.templates:2001
+msgid ""
+"Gutenbach remctl needs a channel on the mixer in order to control the volume "
+"of the music server. [Default is \"Left Front\"]"
+msgstr ""